package com.dsic.gj_erp.exception;


import com.dsic.gj_erp.bean.ResultBean;
import com.fasterxml.jackson.databind.exc.MismatchedInputException;
import org.springframework.dao.DuplicateKeyException;
import org.springframework.dao.InvalidDataAccessResourceUsageException;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.lang.reflect.UndeclaredThrowableException;

@RestControllerAdvice
public class GlobalExceptionHandler{

    @ExceptionHandler(CustomException.class)
    @ResponseBody
    public ResultBean customExceptionHandler(Exception ex) {
        CustomException exception = (CustomException) ex;
        return new ResultBean(false,exception.getCode(),ex.getMessage());
    }

    @ExceptionHandler(UndeclaredThrowableException.class)
    @ResponseBody
    public ResultBean undeclaredThrowableExceptionHandler(Exception ex) {
        if(ex.getCause() instanceof  CustomException){
            CustomException customException = (CustomException) ex.getCause();
            return new ResultBean(false,customException.getCode(),customException.getMessage());
        }
        return new ResultBean(false,10101,ex.toString());
    }


    @ExceptionHandler(Exception.class)
    @ResponseBody
    public ResultBean handle(Exception ex) {
        ex.printStackTrace();
        if (ex instanceof MethodArgumentNotValidException) {
            MethodArgumentNotValidException exception = (MethodArgumentNotValidException) ex;
            return new ResultBean(false,10110,exception.getBindingResult().getAllErrors().get(0).getDefaultMessage());
        }
        if (ex instanceof MismatchedInputException) {
            return new ResultBean(false,10111,"请求参数非法！");
        }
        if(ex instanceof InvalidDataAccessResourceUsageException){
            return new ResultBean(false,10112, "数据库访问异常，请检查参数！");
        }
        if (ex instanceof DuplicateKeyException){
            return new ResultBean(false,10113, "请检查参数！");
        }

        return new ResultBean(false,10101,ex.toString());
    }


}
