package com.dsic.gj_erp.pc.service;

import com.dsic.gj_erp.pc.工序CD;
import com.dsic.gj_erp.pc.设备产能;
import lombok.AllArgsConstructor;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;

@Service
@AllArgsConstructor
public class 工序CD接口 {

    private static final String KEY="gxcd";
    private final RedisTemplate<String,Object> redisTemplate;

    @CachePut(cacheNames = {KEY},key = "#cd.getGx()")
    public Object save(工序CD cd){
        return cd;
    }

    @Cacheable(value = {KEY},key = "#gx")
    public Object get(String gx){
        return new HashMap<>();
    }

    @CacheEvict(value = {KEY}, key="#gx")
    public Object remove(String gx){
        return new HashMap<>();
    }

    public List<工序CD> get(){
        Set<String> keys = redisTemplate.keys(KEY+"::*");
        List<工序CD> list=new ArrayList<>();
        if (keys==null){
            return new ArrayList<>();
        }
        for (String key:keys){
            工序CD _工序CD= (工序CD) redisTemplate.opsForValue().get(key);
            list.add(_工序CD);
        }
        return list;
    }
}
