package com.dsic.gj_erp.pc.service;

import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.pc.工序CD;
import com.dsic.gj_erp.pc.订货计划;
import lombok.AllArgsConstructor;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
public class 订货计划滚动信息接口 {

    private static final String KEY="dhjh";
    private final RedisTemplate<String,Object> redisTemplate;

    @CachePut(cacheNames = {KEY},key = "#plan.getKey()")
    public Object save(订货计划 plan){
        return plan;
    }

    @Cacheable(value = {KEY},key = "#id")
    public Object get(String id){
        return new HashMap<>();
    }

    @CacheEvict(value = {KEY}, key="#id")
    public Object remove(String id){
        return new HashMap<>();
    }

    public List<订货计划> get(){
        Set<String> keys = redisTemplate.keys(KEY+"::*");
        List<订货计划> list=new ArrayList<>();
        if (keys==null){
            return new ArrayList<>();
        }
        for (String key:keys){
            订货计划 _订货计划= (订货计划) redisTemplate.opsForValue().get(key);
            list.add(_订货计划);
        }
        list = list.stream().sorted(Comparator.comparing(订货计划::getMonth).thenComparing(订货计划::getIndex)).collect(Collectors.toList());
        return list;
    }
}
